/*
	Copyright (C) 2005  Brendan G Bohannon (aka: cr88192)
	
	This library is free software; you can redistribute it and/or
	modify it under the terms of the GNU Library General Public
	License as published by the Free Software Foundation; either
	version 2 of the License, or (at your option) any later version.
	
	This library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	Library General Public License for more details.
	
	You should have received a copy of the GNU Library General Public
	License along with this library; if not, write to the Free
	Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
	MA 02111-1307, USA
	
	Email: cr88192@hotmail.com
*/

#include <lz2a.h>


unsigned short warith2_divtab[65536];	//division table
unsigned int warith2_divtab2[65536];	//division table (32 bit)
int warith2_ctx;
unsigned char *warith2_model;	//pairs of counts

int warith2_ctxbits=WARITH2_CTXBITS;
int warith2_ctxmask=(1<<WARITH2_CTXBITS)-1;


//arithmetic frontend/modeler
#if 1
INLINE int WArith2_Predict(unsigned char *model, int ctx)
{
	return(warith2_divtab[((unsigned short *)model)[ctx]]);

//	return(warith2_divtab[
//		model[(ctx<<1)|0]|
//		(model[(ctx<<1)|1]<<8)]);
}
#endif

#if 0
int WArith2_Predict(unsigned char *model, int ctx)
{
	unsigned int i, j, k;

	ctx<<=1;
	i=model[ctx|0];
	j=model[ctx|1];

	k=((i+1)<<WHUFF_WBITS)/(i+j+2);

//	k=(k<WARITH2_CLAMP)?WARITH2_CLAMP:
//		((k>(4096-WARITH2_CLAMP))?(4096-WARITH2_CLAMP):k);
//	k=WHUFF_NEUTRAL;

	return(k);
}
#endif

int WArith2_Update(unsigned char *model, int ctx, int v)
{
	int i;

	i=(ctx<<1);

//	v=v?1:0;
	model[i|v]++;

//	if(model[i|v]>=32768)
//	if(model[i|v]&0x8000)
	if(model[i|v]&0x80)
//	if(model[i|v]&0x20)
	{
		model[i|0]>>=1;
		model[i|1]>>=1;
	}
}

int WArith2_EncodeSymbol(int v)
{
	int i, j, k;

	i=WARITH2_BITS;
	while(i--)
	{
		j=(v>>i)&1;

		k=WArith2_Predict(warith2_model, warith2_ctx);
//		k=WHUFF_NEUTRAL;
		WArith2_Update(warith2_model, warith2_ctx, j);

		WHUFF_OutputBit(j, k);
//		warith2_ctx=((warith2_ctx<<1)|j)&((1<<WARITH2_CTXBITS)-1);
		warith2_ctx=((warith2_ctx<<1)|j)&warith2_ctxmask;
	}
}

int WArith2_DecodeSymbol()
{
	int i, j, k, v;

//	v=0;
	i=WARITH2_BITS;
	while(i--)
	{
//		k=WArith2_Predict(warith2_model, warith2_ctx);
//		k=WHUFF_NEUTRAL;
//		j=WHUFF_InputBit(k);
//		WArith2_Update(warith2_model, warith2_ctx, j);

//		warith2_ctx=v&((1<<WARITH2_CTXBITS)-1);
		j=WHUFF_InputModelBit(warith2_model, warith2_ctx);

//		warith2_ctx=((warith2_ctx<<1)|j)&((1<<WARITH2_CTXBITS)-1);
		warith2_ctx=((warith2_ctx<<1)|j)&warith2_ctxmask;
//		v=(v<<1)|j;
	}

//	return(warith2_ctx&0xFF);
	return(warith2_ctx&((1<<WARITH2_BITS)-1));
//	return(v);
}

int WArith2_EncodeData(byte *in, byte *out, int sz)
{
	int i, j, k, l, ll;
	byte *cs, *ct, *ce, *s2;

	if(!sz)return(0);

//	j=1<<WARITH2_CTXBITS;
	j=1<<warith2_ctxbits;
	warith2_model=malloc(j*2*sizeof(unsigned char));
	for(i=0; i<j*2; i++)warith2_model[i]=0;
	warith2_ctx=0;

	WHUFF_SetupEncode(out);

	cs=in;
	ce=in+sz;
	i=0;

	while(cs<ce)
	{
		j=*cs++;

		if(i<16)printf("%02X ", j);

		WArith2_EncodeSymbol(j);
		i++;
	}
	printf("\n");
	WArith2_EncodeSymbol(258);
	WHUFF_FlushWBits();

#if 1
//test decode
//	for(i=0; i<1024; i++)warith2_model[i]=0;
//	j=1<<WARITH2_CTXBITS;
	j=1<<warith2_ctxbits;
	for(i=0; i<j*2; i++)warith2_model[i]=0;
	warith2_ctx=0;

	WHUFF_SetupDecode(out);

	cs=in;
	ce=in+sz;
	i=0;

	while(cs<ce)
	{
		j=*cs++;

		k=WArith2_DecodeSymbol();

		if(i<16)printf("%02X ", k);
		if(j!=k)
		{
			printf("break at %d\n", i);
			break;
		}
		i++;
	}

	printf("\n");
#endif

	if(huff_winofs>0)huff_winbuf++;
	i=huff_winbuf-out;

	return(i);
}
